<?php
/**
 * getMenu maakt het menu voor de website
 */
function getMenu()
{
 $uitvoer=<<<END
 <table class='menu' summary="">
  <tr>
    <td><input type="submit" name="actie" value="Toon Artikelen">
    </td>
    <td><input type="submit" name="actie" value="Voeg Product Toe">
    </td>
    <td><input type="submit" name="actie" value="Afmelden">
    </td>
    <td><input type="submit" name="actie" value="Toon info">
    </td>
</tr>
 </table>
END;
 return $uitvoer; 
}

/**
 * legeInvoerEnFout maakt een dubbele array met lege strings 
 * die staan voor waarde-fout paren
 * param $aantal is aantal gewenste waarde-fout paren
 */
function legeInvoerEnFout($aantal)
{
	$resultaat = array();
	// voeg per iteratie een waarde-fout paar toe
	for($i=0;$i<$aantal;$i++) $resultaat[$i]=array("",""); 
	return $resultaat;
}
/**
 * toonArtikelInvoerTabel toont de tabel waarmee een product kan worden ingevoerd
 * of het resultaat van de invoer actie kan laten zien
 * param $productEnFout: lijst van producteigenschappen en bestaande uit 
 * 4 invoer velen en eventuele fouten
 *		[
			[naam,foutnaam],
			[prijs,foutprijs],
			[voorraad,foutvoorraad],
			[omschrijving,omschrijving],
 *		]
 * param $alsFormulier true als formulier getoond moet worden, 
                       false als alleen de informatie getoond moet worden
 */
function toonArtikelInvoerTabel($productEnFout,$alsFormulier)
{
 $invoer1="";
 $invoer2="";
 $invoer3="";
 $invoer4="";
 $invoerknop="";
 if($alsFormulier)
 {
 	$invoer1="<input name='naam' value='{$productEnFout[0][0]}'/>"; // naam
 	$invoer2="<input name='prijs' value='{$productEnFout[1][0]}'/>"; // prijs
	$invoer3="<input name='voorraad' value='{$productEnFout[2][0]}'/>"; // voorraad
	$invoer4="<textarea name='omschrijving'/>{$productEnFout[3][0]}</textarea>"; // omschrijving
	
	$invoerknop=<<<END
  <tr>
    <td colspan="3">
      <input type="submit" name="actie" value="Invoeren"/>
   </td>
  </tr>
END;
 }
 else
 {
	$invoer1=$productEnFout[0][0]; // naam
	$invoer2=$productEnFout[1][0]; // prijs
	$invoer3=$productEnFout[2][0]; // voorraad
 	$invoer4=$productEnFout[3][0]; // omschrijving
 }

 $uitvoer=<<<END
  <h3>Voer artikel in</h3>
  <table>
  <tr>
    <td>Geef naam artikel</td>
    <td>$invoer1</td>
    </td>
    <td>{$productEnFout[0][1]}</td>
  </tr>
  <tr>
    <td>Geef prijs</td>
    <td>$invoer2</td>
    <td>{$productEnFout[1][1]}</td>
  </tr>
  <tr>
    <td>Geef aantal in voorraad</td>
    <td>$invoer3</td>
    <td>{$productEnFout[2][1]}</td>
  </tr>
  <tr>
    <td>Geef omschrijving</td>
    <td>$invoer4</td>
    <td>{$productEnFout[3][1]}</td>
  </tr>
  $invoerknop
  </table>
END;
 return $uitvoer;
}

/*
 * artikelInvoeren leest de invoer uit de $_POST variabele,
 * test de invoer, geeft foutmeldingen bij mislukkingen en voegt als
 * er niets misgaat een record toe aan de database. 
 */
function artikelInvoeren()
{
 $fout1="";
 $fout2="";
 $fout3="";
 $fout4="";
 $naam = "";
 $prijs = "";
 $voorraad = "";
 $omschrijving = "";
 $uitvoer ="";
 $melding=""; // initialisatie van variabele om connectie foutmelding in te plaatsen
 global $db; // Haal een verwijzing naar de huidige connectie in database.php
 //verbinding maken met database
 if(!$db) maakVerbinding($db,$melding);
 if(!$db) // test verbinding
 {
    // mislukt
    $uitvoer=$melding;
 }
 else
 {
   // isset is een functie die kijkt of een element in een array bestaat
   // post variabelen ophalen 
   // $db->real_escape_string() functie wordt gebruikt om foute invoer te voorkomen
   if(isset($_POST["prijs"]))
   {
    $prijs = $db->real_escape_string($_POST["prijs"]);
   }
   if(isset($_POST["naam"]))
   {
    $naam = $db->real_escape_string($_POST["naam"]);
   }
   if(isset($_POST["voorraad"]))
   {
    $voorraad = $db->real_escape_string($_POST["voorraad"]);
   }
   if(isset($_POST["omschrijving"]))
   {
    $omschrijving= $db->real_escape_string($_POST["omschrijving"]);
   }
   // test of er waarden en getallen zijn
   if( !empty($naam) && 
      ((!empty($prijs) && is_numeric($prijs))||$prijs=="0") && 
      ((!empty($voorraad) && is_numeric($voorraad))||$voorraad=="0") && 
      !empty($omschrijving) ) 
   {    
        // Maak van getal1 een double
        $prijs=(double)$prijs; 
      
        //opdracht geven aan database
        $query = "INSERT INTO product (naam,prijs,voorraad,omschrijving) VALUES ('$naam','$prijs','$voorraad','$omschrijving')";

        if($resultaat = $db->query($query))
        {
		  $uitvoer = toonArtikelInvoerTabel( array(
											array($naam,$fout1),
											array($prijs,$fout2),
											array($voorraad,$fout3),
											array($omschrijving,$fout4)
										),false);
          $uitvoer .= "Artikel is ingevoerd";
        }
        else
        {
          $uitvoer = toonArtikelInvoerTabel( array(
											array($naam,$fout1),
											array($prijs,$fout2),
											array($voorraad,$fout3),
											array($omschrijving,$fout4)
										),true);
          $uitvoer .= "Fout uitvoeren query! $query";
        }
   }
   else // er is een fout
   {
     if(empty($naam)){$fout1="Er moet een naam worden ingevuld";}
     if(empty($prijs)){$fout2="Er moet een getal worden ingevuld";}
     elseif(!is_numeric($prijs)){$fout2="$prijs is geen getal";}
     if(empty($voorraad)){$fout3="Er moet een getal worden ingevuld";}
     elseif(!is_numeric($voorraad)){$fout3="$voorraad is geen getal";}
     if(empty($omschrijving)){$fout4="Er moet een omschrijving worden ingevuld";}
	 
     $uitvoer = toonArtikelInvoerTabel( array(
											array($naam,$fout1),
											array($prijs,$fout2),
											array($voorraad,$fout3),
											array($omschrijving,$fout4)
										),true);
   }
   //sluit database
   verbreekVerbinding();
 }
 return $uitvoer;
}

/*
 * toonArtikelWijzigTabel geeft een tabel met invoervelden gevuld de waarden voor
 * het in de $_POST aanwezige productid veld en gegeven als formulier als $alsFormulier de 
 * waarde true heeft.
 * param &fouten: array met 4 mogelijke fouten
 *  $fouten[0]: melding voor als er bij de invoer van naam een fout is opgetreden
 *  $fouten[1]: melding voor als er bij de invoer van prijs een fout is opgetreden	
 *  $fouten[2]: melding voor als er bij de invoer van voorraad een fout is opgetreden	
 *  $fouten[3]: melding voor als er bij de invoer van omschrijving een fout is opgetreden	
 * param $alsFormulier: true -&gt; invulformulier; false -&gt; tabel
 */
function toonArtikelWijzigTabel($fouten,$alsFormulier)
{
 $productid = "";
 $naam = "";
 $prijs = "";
 $voorraad = "";
 $omschrijving = "";
 $uitvoer ="";
 $melding=""; // initialisatie van variabele om connectie foutmelding in te plaatsen
 global $db; // Haal een verwijzing naar de huidige connectie in database.php
 if(isset($_POST["productid"]))
 {
  if(!$db) maakVerbinding($db,$melding);
  if(!$db) // test verbinding
  {
    // mislukt
    $uitvoer=$melding;
  }
  else
  {
     $productid = $db->real_escape_string($_POST["productid"]);
  
	 //opdracht geven aan database
     $query = "SELECT * FROM product WHERE id='$productid'";

     if($resultaat = $db->query($query))
     {
       list($nummer,$naam,$prijs,$voorraad, $omschrijving) = $resultaat->fetch_row();
       $invoer1="";
       $invoer2="";
       $invoer3="";
       $invoer4="";
       $invoer5="";
       $invoerknop="";
       if($alsFormulier)
       {
       	$invoer1="<input name='naam' value='$naam'/>";
       	$invoer2="<input name='prijs' value='$prijs'/>";
      	$invoer3="<input name='voorraad' value='$voorraad'/>";
      	$invoer4="<textarea name='omschrijving'/>$omschrijving</textarea>";
     	  $invoer5="<input name='productid' value='$productid' readonly />";
       
      	$invoerknop=<<<END
        <tr>
          <td colspan="3">
            <input type="submit" name="actie" value="Wijziging Doorvoeren"/>
         </td>
        </tr>
END;
       }
       else
       {
      	$invoer1=$naam;
      	$invoer2=$prijs;
      	$invoer3=$voorraad;
       	$invoer4=$omschrijving;
        $invoer5=$productid;
       }
      
       $uitvoer=<<<END
  <h3>Wijzig artikel</h3>
  <table>
  <tr>
    <td>product nummer</td>
    <td colspan="2">$invoer5</td>
  </tr>
  <tr>
    <td>Geef naam artikel</td>
    <td>$invoer1</td>
    <td>{$fouten[0]}</td>
  </tr>
  <tr>
    <td>Geef prijs</td>
    <td>$invoer2</td>
    <td>{$fouten[1]}</td>
  </tr>
  <tr>
    <td>Geef aantal in voorraad</td>
    <td>$invoer3</td>
    <td>{$fouten[2]}</td>
  </tr>
  <tr>
    <td>Geef omschrijving</td>
    <td>$invoer4</td>
    <td>{$fouten[3]}</td>
  </tr>
	$invoerknop
  </table>
END;

     }
     else
     {
       $uitvoer .= "Fout uitvoeren query! $query";
     }
     //sluit database
     verbreekVerbinding();
	 
  }    	
 }
 else
 {
 	$uitvoer = "Product id niet aanwezig!";
 }
 return $uitvoer;
}

/*
 ProductWijzigen leest de invoer uit de $_POST variabele,
 test de invoer, geeft foutmeldingen bij mislukkingen en veranderd als
 er niets misgaat het record in de database. 
 */
function productWijzigen()
{
 $fout1="";
 $fout2="";
 $fout3="";
 $fout4="";
 $productid="";
 $naam = "";
 $prijs = "";
 $voorraad = "";
 $omschrijving = "";
 $uitvoer ="";
 $melding=""; // initialisatie van variabele om connectie foutmelding in te plaatsen
 global $db; // Haal een verwijzing naar de huidige connectie in database.php
 //verbinding maken met database
 if(!$db) maakVerbinding($db,$melding);
 if(!$db) // test verbinding
 {
   // mislukt
   return $melding;
 }
 else
 {
   // isset is een functie die kijkt of een element in een array bestaat
   // post variabelen ophalen 
   if(isset($_POST["productid"]))
   {
    $productid = $db->real_escape_string($_POST["productid"]);
   }
   if(isset($_POST["prijs"]))
   {
    $prijs = $db->real_escape_string($_POST["prijs"]);
   }
   if(isset($_POST["naam"]))
   {
    $naam = $db->real_escape_string($_POST["naam"]);
   }
   if(isset($_POST["voorraad"]))
   {
    $voorraad = $db->real_escape_string($_POST["voorraad"]);
   }
   if(isset($_POST["omschrijving"]))
   {
    $omschrijving= $db->real_escape_string($_POST["omschrijving"]);
   }
   // test of er waarden en getallen zijn
   if( !empty($productid) && is_numeric($productid) && 
       !empty($naam) && 
       ((!empty($prijs) && is_numeric($prijs))||$prijs=="0") && 
       ((!empty($voorraad) && is_numeric($voorraad))||$voorraad=="0") && 
       !empty($omschrijving) ) 
   {    
        // Maak van getal1 een double
        $prijs=(double)$prijs; 
      
        //opdracht geven aan database
        $query = "UPDATE product SET naam = '$naam', prijs = '$prijs', voorraad= '$voorraad', omschrijving='$omschrijving' WHERE id = $productid";

        if($resultaat = $db->query($query))
        {
         $uitvoer = toonArtikelWijzigTabel(array("","","",""),false);
		 $uitvoer .= "Artikel is gewijzigd";
        }
        else
        {
         $uitvoer = toonArtikelWijzigTabel(array("","","",""),true);
         $uitvoer .= "Fout uitvoeren query! $query";
        }
   }
   else // er is een fout
   {
     if(empty($naam)){$fout1="Er moet een naam worden ingevuld";}
  	 if(empty($prijs)){$fout2="Er moet een getal worden ingevuld";}
     elseif(!is_numeric($prijs)){$fout2="$prijs is geen getal";}
     if(empty($voorraad)){$fout3="Er moet een getal worden ingevuld";}
     elseif(!is_numeric($voorraad)){$fout3="$voorraad is geen getal";}
     if(empty($omschrijving)){$fout4="Er moet een omschrijving worden ingevuld";}
  	 $uitvoer = toonArtikelWijzigTabel(array($fout1,$fout2,$fout3,$fout4),true);
   }
   //sluit database
   verbreekVerbinding();
 }
 return $uitvoer; 
}
/*
 * toonArtikelVerwijderTabel toont een tabel met waarden voor
 * het record behorende bij het in de $_POST aanwezige productid
 * en wordt weergegeven als formulier als $alsFormulier de waarde true heeft.
 * param $alsFormulier: true -> verzend formulier; false -> tabel
 */
function toonArtikelVerwijderTabel($alsFormulier)
{
 $productid = "";
 $naam = "";
 $prijs = "";
 $voorraad = "";
 $omschrijving = "";
 $uitvoer ="";
 $melding=""; // initialisatie van variabele om connectie foutmelding in te plaatsen
 global $db; // Haal een verwijzing naar de huidige connectie in database.php
 if(!$db) $db=maakVerbinding($db,$melding);
 if(!$db) // test verbinding
 {
    // mislukt
    $uitvoer=$melding;
 }
 else
 {
   if(isset($_POST["productid"]))
   {
     $productid = $db->real_escape_string($_POST["productid"]);
     //opdracht geven aan database
     $query = "SELECT * FROM product WHERE id='$productid'";

     if($resultaat = $db->query($query))
     {
       list($productid, $naam, $prijs, $voorraad, $omschrijving) = $resultaat->fetch_row();
       $invoer="<input name='productid' value='$productid' readonly />";
       $invoerknop="";
       if($alsFormulier)
       {
        $invoerknop=<<<END
        <tr>
          <td colspan="3">
            <input type="submit" name="actie" value="Bevestig Verwijderen"/>
         </td>
        </tr>
END;
       }
       $uitvoer=<<<END
  <h3>Verwijder artikel</h3>
  <table>
  <tr>
    <td>product nummer</td>
    <td>$invoer</td>
  </tr>
  <tr>
    <td>naam artikel</td>
    <td>$naam</td>
  </tr>
  <tr>
    <td>prijs</td>
    <td>$prijs</td>
  </tr>
  <tr>
    <td>voorraad</td>
    <td>$voorraad</td>
  </tr>
  <tr>
    <td>omschrijving</td>
    <td>$omschrijving</td>
  </tr>
	$invoerknop
  </table>
END;

     }
     else
     {
       $uitvoer .= "Fout uitvoeren query! $query";
     }
   }
   else
   {
   	$uitvoer = "Product id niet aanwezig!";
   }
   //sluit database
   verbreekVerbinding();
 } 
 return $uitvoer;
}

/*
 * productVerwijderen leest de invoer uit de $_POST variabele,
 * verwijdert het record met het juiste product id. 
 */
function productVerwijderen()
{
 $productid="";
 $melding=""; // initialisatie van variabele om connectie foutmelding in te plaatsen
 global $db; // Haal een verwijzing naar de huidige connectie in database.php
//verbinding maken met database
 if(!$db) maakVerbinding($db,$melding);
 if(!$db) // test verbinding
 {
   // mislukt
   $uitvoer=$melding;
 }
 else
 {
   // isset is een functie die kijkt of een element in een array bestaat
   // post variabelen ophalen 
   if(isset($_POST["productid"]))
   {
    $productid = $db->real_escape_string($_POST["productid"]);
   }
   // test of er waarden en getallen zijn
   if( !empty($productid) && is_numeric($productid) ) 
   {    
        //opdracht geven aan database
        $query = "DELETE FROM product WHERE id = $productid";

        if($resultaat = $db->query($query))
        {
          $uitvoer = "Artikel $productid is verwijderd.<br/>";
          $uitvoer .= toonArtikelenLijst($db);
        }
        else
        {
          $uitvoer = toonArtikelVerwijderTabel($db,false);
          $uitvoer .= "Fout uitvoeren query! $query";
        }
   }
   else // er is een fout
   {
     $uitvoer =  "Geen product id";
   }
   //sluit database
   verbreekVerbinding();
 }
 return $uitvoer; 
}
/*
 * De functie toonArtikelenLijst voert de sql query voor 
 * de productenlist uit op de database en maakt met het resultaat van deze
 * query een tabel in html.
 * Deze html wordt geretourneerd naar de aanroepende code.
 */
function toonArtikelenLijst()
{
  // maak verbinding
  $uitvoer=""; // initialisatie van variabele om uit voer in te plaatsen
  $melding=""; // initialisatie van variabele om connectie foutmelding in te plaatsen
  global $db; // Haal een verwijzing naar de huidige connectie in database.php
  if(!$db) maakVerbinding($db,$melding);
  if(!$db) // test verbinding
  {
    // mislukt
    $uitvoer="Er is geen database connectie! ".$melding;
  }
  else
  {
     $query = "SELECT * from product";
     $resultaat = $db->query($query);
     if($resultaat)
     {            
      // resultaat tot uitvoer verwerken
      // maken tabel 
      $uitvoer .= "<table summary=''>\n";
      $uitvoer .= "<tr>";
      $uitvoer .= "<td>nummer</td>";
      $uitvoer .= "<td>naam</td>";
      $uitvoer .= "<td>prijs</td>";
      $uitvoer .= "<td>voorraad</td>";
      $uitvoer .= "<td>omschrijving</td>";
      $uitvoer .= "<td>wijzig</td>";
      $uitvoer .= "<td>verwijder</td>";
      $uitvoer .= "</tr>\n";
      // lus door alle rijen aanezig in het resultaat
      while(list($nummer,$naam,$prijs,$voorraad, $omschrijving) = $resultaat->fetch_row())
      {
         $uitvoer .= "<tr><td>$nummer</td><td>$naam</td><td>$prijs</td><td>$voorraad</td><td>$omschrijving</td>";
         $uitvoer .= "<td><form action='{$_SERVER['PHP_SELF']}' method='post'>";
         $uitvoer .= "<input type='hidden' name='productid' value=$nummer>";
         $uitvoer .= "<input type='submit' name='actie' value='wijzig'></form></td>";
         $uitvoer .= "<td><form  action='{$_SERVER['PHP_SELF']}' method='post'>";
         $uitvoer .= "<input type='hidden' name='productid' value=$nummer>";
         $uitvoer .= "<input type='submit' name='actie' value='verwijder'></form></td></tr>";
         $uitvoer .= "</tr>\n"; 
      }
      $uitvoer .="</table>";
     }
     else
     {
         $uitvoer .= "<br/>Fout in query";
     }
  }
  //sluit database
  verbreekVerbinding();         
  return $uitvoer;    // Stuur de waarde van $uitvoer terug     
}

/*
 * toonVerbindingStatus() is een fucntie die de database connectie test.
 * Het resultaat is een tekst die het succes of niet van het maken van de connectie
 * met de database manager weergeeft
 * param &$db: verwijzing naar de database
 */
function toonVerbindingStatus()
{ 
 $uitvoer=""; // initialisatie van variabele om uit voer in te plaatsen
 $melding=""; // initialisatie van variabele om connectie foutmelding in te plaatsen
 global $db; // Haal een verwijzing naar de huidige connectie in database.php
 // maak verbinding
 maakVerbinding($db,$melding);
 if(!$db) // test verbinding
 {
  // mislukt
  $uitvoer=$melding;
 }
 else
 {
  $uitvoer=$melding; 
  // Volgende is niet nodig maar alleen om functionaliteit maakVerbinding te laten zien
  // verbind nog een keer 
  maakVerbinding($db,$melding);
  $uitvoer.="<br/>".$melding;  
  //sluit database
  verbreekVerbinding();
  // verbind nog een keer;
  $db=maakVerbinding($db,$melding);
  $uitvoer.="<br/>".$melding;  
  verbreekVerbinding();
  // Einde niet nodig
 }
 return $uitvoer;
}

//einde van het PhP blok
?>
