<?php
// Opslaan als index.php 
// Start sessie
session_start();
// Laad database code
require_once("database.php");
// Laad code voor de acties die we op de database gaan doen
require_once("actie.php");
// Laad code voor de acties die we voor het login proces nodig hebben
require_once("authorisatie.php");
// Zorg ervoor dat de bladzijde altijd vanuit de server wordt ververst
// Zie https://www.imperva.com/learn/performance/cache-control/ en
// https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Cache-Control
header("Cache-control: no-store");

// declareer variabelen

$menu = "";
$uitvoer="";
$user="";
$password="";
$toegelaten=false;
$toegelaten_fout_boodschap="";
$uitvoer="";
$actie="";

// lees de actie in
if( isset($_POST['actie']) && !empty($_POST['actie'])  )
{
 $actie=$_POST['actie'];
}

// test of user als is ingelogd
if(	isset($_SESSION["access"]) && $_SESSION["access"] == "toegelaten" && 
	isset($_SESSION["rol"]) && $_SESSION["rol"]=="medewerker")
{
 $toegelaten=true;
 $user=$_SESSION["user"];
 $menu = getMenu(); // Haal het menu door de functie getMenu() uit acties.php op te roepen
}
else // zo niet dan komt de bezoeker mogelijkerwijs van het inlog scherm.
{
	if($actie=="Log in" && checkLogin() )
	{
	 $menu = getMenu(); 
	}
	$uitvoer= $toegelaten_fout_boodschap."<br/>";
}

// Als je bent toegelaten toon je de hoofdbladzijde anders
// toon je het inlogscherm
if($toegelaten)
{
    // Als ingelogd persoon kun je de volgende acties uitvoeren
	switch($actie)
    {
	  case "Afmelden": afmelden(); 
			$uitvoer = getLoginScreen();
			$menu=""; 
			break;
	  case "Toon info": $uitvoer=tooninfo(); break;
	  case "verwijder":
			$uitvoer=toonArtikelVerwijderTabel(true); // Voer de functie toonArtikelVerwijderTabel() in acties.php uit
			break;
	  case "Bevestig Verwijderen":
			$uitvoer=productVerwijderen(); // Voer de functie ProductWijzigen() in acties.php uit
			break;
	  case "wijzig":
			$uitvoer=toonArtikelWijzigTabel(array_fill(0,4,""),true); // Voer de functie toonArtikelWijzigTabel met 4 nu nog lege fouten in acties.php uit
			break;
	  case "Wijziging Doorvoeren":
			$uitvoer=productWijzigen(); // Voer de functie ProductWijzigen() in acties.php uit
			break;
	  case "Invoeren":
			$uitvoer=artikelInvoeren(); // Voer de functie ProductInvoeren() in acties.php uit
			break;
	  case "Voeg Product Toe":
			// Voer de functie toonArtikelInvoerTabel() in acties.php uit met 4 lege waarde fout paren
			$uitvoer=toonArtikelInvoerTabel(legeInvoerEnFout(4),true);  
			break;
	  case "Toon Artikelen": $uitvoer=toonArtikelenLijst(); break;
	  case "Toon VerbindingStatus": $uitvoer = toonVerbindingStatus(); break;
	  default: $uitvoer = "<h1>Welkom bij ons garagebedrijf</h1>"; break;
	}
}
else
{
	// Als niet ingelogd persoon kun je de volgende acties uitvoeren
	switch($actie)
	{
	  case "Registreren":  $uitvoer = "De functionaliteit Registreren moet nog worden gemaakt"; 
      default:  $uitvoer .= getLoginScreen(); break;
	}
}
echo <<<END
<!DOCTYPE HTML>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />    
<title>Garagehuis</title>
</head>
<body>
<form action="{$_SERVER['PHP_SELF']}" method="POST">
$menu
<hr>
$uitvoer
</form>
</body>
</html>
END;
?>