<?php
/**
 * authorisatie.php bevat de code nodig voor het aanmelden bij de applicatie
 * nodig is code uit database.php
 */
 
global $toegelaten_fout_boodschap;
global $user;
global $password;
global $toegelaten;
 
/**
 * checkLogin is de eerste functie die wordt aangeroepen in het authorisatie proces.
 * Zijn de formulier gegevens aanwezig dan wordt via de checkUser functie de aanwezigheid van 
 * de gebruiker in de database worden gecontroleerd.
 */
function checkLogin()
{
  global $toegelaten_fout_boodschap;
  global $user;
  global $password;
  global $toegelaten;
  $toegelaten=false;
  /* Haal gebruikersnaam en wachtwoord uit het formulier  */
  if( isset($_POST['loginname']) && !empty($_POST['loginname'])  )
  {
    $user = $_POST['loginname'];
    if( isset($_POST['password']) && !empty($_POST['password']) )
    {
     $password = $_POST['password'];
     if($toegelaten=checkUser($user,$password))
     {
       /* toegang is verkregen */
	   $toegelaten_fout_boodschap = "$user, welkom bij mijn webapplicatie";
     }
     else
     {
	   /* toegang geweigerd */
	   afmelden();
     }
    }
  }
  return $toegelaten; 
}


/**
 * checkUser: test of de gebruiker en zijn wachtwoord bestaan.
 * Zo niet laat het inlog scherm weer zien anders krijg je toegang
 * NB: in garagebedrijfnieuwenhuis voorbeeld is bij de klanten het 
 * wachtwoord ingesteld op "123<Achternaam>"
 */
function checkUser($user,$password)
{
  global $toegelaten_fout_boodschap;
  $toegelaten=false;
  $melding=""; // initialisatie van variabele om connectie foutmelding in te plaatsen
  global $db; // Haal een verwijzing naar de huidige connectie in database.php
  //verbinding maken met database
  if(!$db) maakVerbinding($db,$melding);
  if ($db)
  {
     $user=$db->real_escape_string($user);
     $password=$db->real_escape_string($password);
     /* De SQL vraag voor de toegang */
     $query = "SELECT id,loginname,password FROM klant ".
              " WHERE loginname = '$user'  AND password = '$password'";
  
     /* Stuur de vraag naar de database manager */
     $result = $db->query($query);
  
     /* Als er een resultaat komt dan is toegang toegestaan anders niet */
     if (list($id,$loginname,$password)=$result->fetch_row())
     {
        $toegelaten_fout_boodschap= "Toegang verkregen: Welkom, $user!";
        $toegelaten=true;
        $_SESSION["access"] = "toegelaten";
        $_SESSION["user"] = $user;
        $_SESSION["klantnummer"] = $id;
		$_SESSION["rol"] = "admin";		
     }
     else
         $toegelaten_fout_boodschap= "Toegang gewijgerd: Probeer het nogmaals.";
    
     verbreekVerbinding();
  }
  else
  {
     $toegelaten_fout_boodschap= 
     "interne fout: Probeer in contact te komen met het beheer van deze site!";
  }
  return   $toegelaten;
}

/**
 * afmelden: functie die moet worden aangeroepen als je wil afmelden.
 */
function afmelden()
{
  // Maak de Sessions variabele op de server leegleeg
  $_SESSION = array();
  // ruim alles op bij de client
  session_destroy();
}

/**
 * tooninfo: functie toont de gegevens van de gebruiker.
 */
function tooninfo()
{
  $uitvoer="";
  $melding=""; // initialisatie van variabele om connectie foutmelding in te plaatsen
  global $toegelaten_fout_boodschap;
  global $db; // Haal een verwijzing naar de huidige connectie in database.php
  //verbinding maken met database
  if(!$db) maakVerbinding($db,$melding);
  if ($db)
  {
     /* SQL statement to query the database */
     $query = "SELECT * FROM klant ".
              " WHERE id = '".$_SESSION["klantnummer"]."'";
  
     /* query the database */
     $result = $db->query($query);
     if($result)
     {
       /* Allow access if a matching record was found, else deny access. */
       if (list($id,$loginname,$password,$voornaam,$achternaam,$straat,$huisnummer,$postcode,$woonplaats)=$result->fetch_row())
       {
        $uitvoer .= "Jij bent $voornaam $achternaam en woont op $straat in $woonplaats.<br/>".
                    "Als gebruikersnaam heb je: $loginname Je password is geheim.";
       }
     }
     else
         $uitvoer = "Fout in query.";
    
     verbreekVerbinding();
  }
  else
  {
     $uitvoer.= 
     "interne fout: Probeer in contact te komen met het beheer van deze site!".
      mysql_error($db);
  }
  return   $uitvoer;
}

/**
 * getLoginScreen: geeft de html code voor het inlogscherm.
 */
function getLoginScreen()
{
 global $toegelaten_fout_boodschap;
 global $user;
 
 $uitvoer=<<<END
<h1>Login in mijn applicatie</h1>
<h2>$toegelaten_fout_boodschap</h2>
<form action="{$_SERVER['PHP_SELF']}" method="post">
  <label for="loginname">Login naam</label>
  <input type="text" name="loginname" id="loginname" value="$user"/>
  <br />
  <label for="password">Password</label>
  <input type="password" name="password" id="password" />
  <br />
  <input type="submit" name="actie" value="Log in" />
</form>
END;
 
 return $uitvoer;
}

//einde van het PhP blok
?>