<?php
// sla op als database.php
/* eerst definiëren we twee global variabelen $db en $melding.
 Een globale variabele is een variabele die we overal in de code
 kunnen benaderen. Voordelen van een globale variabele zijn
 dat een dergelijke variabele overal vanuit de code benaderbaar is
 en dat er communicatie mogelijk is vanuit verschillende 
 functies met behulp van deze variabelen zonder dat de functie
 argumenten nodig heeft.
 Een groot nadeel is dat het naarmate projecten groter worden
 lastig is om globale variabelen goed in het oog te houden.
*/
global $melding;  // zal worden gebruikt voor foutmeldingen in database functies
global $db;       // zal worden gebruikt om een database connectie in op te slaan
$melding="";   // zal worden gebruikt voor foutmeldingen in database functies
$db=null;   // zet de connectie eerst op null

/**
 * maakVerbinding probeert een verbinding met de database manager op te zetten
 * param &$db: verwijzing naar de globale variabele die de connectie aangeeft
 * param &$melding: verwijzing naar variabele die de meldingen bijhoudt
 */
function maakVerbinding(&$db,&$melding)
{
  // toegangsgegevens mysql database service
 $server = "localhost";
 $user = "leerling";
 $wachtwoord = "rloleerling";
 $database ="garagebedrijf"; 

 // test of er al een verbinding is;
 if($db)
 {
  $melding = "Er is al een verbinding";
 }
 else
 {
  // verbinding maken met mysql database service
  $db = new mysqli($server, $user, $wachtwoord,$database);
  if ($db->connect_errno) 
  {
    $melding ="Helaas, mysql kan geen verbinding maken" . $db->connect_error;
    $db=null;
  }
  else
  {
    $db->set_charset('utf8'); // Zorgt dat speciale tekens ook uit de database worden gehaald
    $melding = "Connectie met databse gemaakt";
  }
 }
 return $db;
}
/**
 * verbreekVerbinding verbreekt de connectie met de mysql server en
 * zet de globale variabele $db weer op de startwaarde.
 */
function verbreekVerbinding()
{
 global $db; // Haal een verwijzing naar de huidige connectie in database.php
 if($db)
 {
  $db->close();
  $db=null;
 }
}
?>